>From 3fb01f9aa12a662d9a0382b94a071a36683c5f16 Mon Sep 17 00:00:00 2001
From: Abhishek Koneru <akoneru@redhat.com>
Date: Wed, 3 Apr 2013 11:15:22 -0400
Subject: [PATCH] Remove the respawn logic in deploy scripts.

Remove all the declarations, definitions and invocations of respawn()
method in the deploment scripts. Remove the -u update option in pkispawn
script.

Ticket #542
---
 base/deploy/man/man8/pkispawn.8                    |    5 +-
 base/deploy/src/pkispawn                           |   55 +++++---------------
 base/deploy/src/scriptlets/configuration.py        |    5 --
 base/deploy/src/scriptlets/finalization.py         |    5 --
 .../deploy/src/scriptlets/infrastructure_layout.py |    5 --
 base/deploy/src/scriptlets/initialization.py       |   13 -----
 base/deploy/src/scriptlets/instance_layout.py      |    5 --
 base/deploy/src/scriptlets/pkiconfig.py            |    4 --
 base/deploy/src/scriptlets/pkimessages.py          |   15 ------
 base/deploy/src/scriptlets/pkiparser.py            |   16 +-----
 base/deploy/src/scriptlets/pkiscriptlet.py         |    6 ---
 base/deploy/src/scriptlets/security_databases.py   |    5 --
 base/deploy/src/scriptlets/selinux_setup.py        |    6 ---
 base/deploy/src/scriptlets/slot_substitution.py    |    5 --
 base/deploy/src/scriptlets/subsystem_layout.py     |    5 --
 base/deploy/src/scriptlets/webapp_deployment.py    |    6 ---
 16 files changed, 16 insertions(+), 145 deletions(-)

diff --git a/base/deploy/man/man8/pkispawn.8 b/base/deploy/man/man8/pkispawn.8
index d3e98030295da0539199b3f2eb58b94543e52d1c..e28d63587a49d344f799f7caa798e189cbb434d3 100644
--- a/base/deploy/man/man8/pkispawn.8
+++ b/base/deploy/man/man8/pkispawn.8
@@ -18,7 +18,7 @@
 pkispawn \- Sets up an instance of Certificate Server.
 
 .SH SYNOPSIS
-pkispawn -s <subsystem> -f <config_file> [-h] [-u] [-v] [-p <prefix>]
+pkispawn -s <subsystem> -f <config_file> [-h] [-v] [-p <prefix>]
 
 .SH DESCRIPTION
 Sets up an instance of Certificate Server.  This utility creates any of the Java-based Certificate Server subsystems (CA, KRA, OCSP, and TKS). 
@@ -74,9 +74,6 @@ Specifies the path to the user-defined configuration file.  This file contains d
 .B -h, --help
 Prints additional help information.
 .TP
-.B -u
-Runs this script in upgrade mode, to update an existing instance.
-.TP
 .B -v
 Displays verbose information about the installation.  This flag can be provided multiple times to increase verbosity.  See
 .B pkispawn -h 
diff --git a/base/deploy/src/pkispawn b/base/deploy/src/pkispawn
index 447240ecf19c6eda84771f51b63c876afed7d2a2..d36de33d5bdea3893bb4c6cd350c54282816d9ae 100755
--- a/base/deploy/src/pkispawn
+++ b/base/deploy/src/pkispawn
@@ -110,10 +110,6 @@ def main(argv):
         help='configuration filename '
             '(MUST specify complete path)')
 
-    parser.optional.add_argument('-u',
-        dest='pki_update_flag', action='store_true',
-        help='update instance of specified subsystem')
-
     args = parser.process_command_line_arguments(argv)
 
     config.default_deployment_cfg = config.PKI_DEPLOYMENT_DEFAULT_CONFIGURATION_FILE
@@ -122,9 +118,6 @@ def main(argv):
     if args.user_deployment_cfg is not None:
         config.user_deployment_cfg = str(args.user_deployment_cfg).strip('[\']')
 
-    # -u
-    config.pki_update_flag = args.pki_update_flag
-
     parser.validate()
     interactive = False
 
@@ -290,30 +283,17 @@ def main(argv):
 
     # Enable 'pkispawn' logging.
     rv = 0
-    if not config.pki_update_flag:
-        config.pki_log_dir = config.pki_root_prefix +\
-                             config.PKI_DEPLOYMENT_LOG_ROOT
-        config.pki_log_name = "pki" + "-" +\
-                              config.pki_subsystem.lower() +\
-                              "-" + "spawn" + "." +\
-                              config.pki_timestamp + "." + "log"
-        rv = pkilogging.enable_pki_logger(config.pki_log_dir,
-                                          config.pki_log_name,
-                                          config.pki_log_level,
-                                          config.pki_console_log_level,
-                                          "pkispawn")
-    else:
-        config.pki_log_dir = config.pki_root_prefix +\
-                             config.PKI_DEPLOYMENT_LOG_ROOT
-        config.pki_log_name = "pki" + "-" +\
-                              config.pki_subsystem.lower() +\
-                              "-" + "respawn" + "." +\
-                              config.pki_timestamp + "." + "log"
-        rv = pkilogging.enable_pki_logger(config.pki_log_dir,
-                                          config.pki_log_name,
-                                          config.pki_log_level,
-                                          config.pki_console_log_level,
-                                          "pkirespawn")
+    config.pki_log_dir = config.pki_root_prefix +\
+                         config.PKI_DEPLOYMENT_LOG_ROOT
+    config.pki_log_name = "pki" + "-" +\
+                          config.pki_subsystem.lower() +\
+                          "-" + "spawn" + "." +\
+                          config.pki_timestamp + "." + "log"
+    rv = pkilogging.enable_pki_logger(config.pki_log_dir,
+                                      config.pki_log_name,
+                                      config.pki_log_level,
+                                      config.pki_console_log_level,
+                                      "pkispawn")
     if rv != OSError:
         config.pki_log = rv
     else:
@@ -337,12 +317,8 @@ def main(argv):
     # Combine the various sectional dictionaries into a PKI master dictionary
     parser.compose_pki_master_dictionary()
 
-    if not config.pki_update_flag:
-        config.pki_master_dict['pki_spawn_log'] = config.pki_log_dir + "/" +\
-                                                  config.pki_log_name
-    else:
-        config.pki_master_dict['pki_respawn_log'] = config.pki_log_dir + "/" +\
-                                                    config.pki_log_name
+    config.pki_master_dict['pki_spawn_log'] = config.pki_log_dir + "/" +\
+                                              config.pki_log_name
     config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
                          extra=config.PKI_INDENTATION_LEVEL_0)
     config.pki_log.debug(pkilogging.format(config.pki_master_dict),
@@ -392,10 +368,7 @@ def main(argv):
                                pki_scriptlet,
                                fromlist = [pki_scriptlet])
         instance = scriptlet.PkiScriptlet()
-        if not config.pki_update_flag:
-            rv = instance.spawn()
-        else:
-            rv = instance.respawn()
+        rv = instance.spawn()
         if rv != 0:
             sys.exit(1)
     config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
diff --git a/base/deploy/src/scriptlets/configuration.py b/base/deploy/src/scriptlets/configuration.py
index 7bd1b017a8bef03aa584160912ed50546295a88a..783f649079a9f6ece8e9dee7358a0c7cc391a774 100644
--- a/base/deploy/src/scriptlets/configuration.py
+++ b/base/deploy/src/scriptlets/configuration.py
@@ -129,11 +129,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
 
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.CONFIGURATION_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         config.pki_log.info(log.CONFIGURATION_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
diff --git a/base/deploy/src/scriptlets/finalization.py b/base/deploy/src/scriptlets/finalization.py
index 6ddc98d0361f6c2a978dba50081ae5e0fabceb95..6da46469cdb58dc72ec4a9a2dee951c41c963b28 100644
--- a/base/deploy/src/scriptlets/finalization.py
+++ b/base/deploy/src/scriptlets/finalization.py
@@ -91,11 +91,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             util.configuration_file.display_configuration_url()
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.FINALIZATION_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         config.pki_log.info(log.FINALIZATION_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
diff --git a/base/deploy/src/scriptlets/infrastructure_layout.py b/base/deploy/src/scriptlets/infrastructure_layout.py
index 69a905849624a43ce674eebe7624d6f8e7adf44b..c523c8514a247c96f0da8f27e225b252cc97341b 100644
--- a/base/deploy/src/scriptlets/infrastructure_layout.py
+++ b/base/deploy/src/scriptlets/infrastructure_layout.py
@@ -90,11 +90,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             util.directory.create(master['pki_configuration_path'])
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.ADMIN_DOMAIN_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         config.pki_log.info(log.ADMIN_DOMAIN_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
diff --git a/base/deploy/src/scriptlets/initialization.py b/base/deploy/src/scriptlets/initialization.py
index 3494ebdc7a296e12553b5ddfb6d82f03240e01e4..f3839fb059a6b8346705bbb3ec8dd3c594282e8e 100644
--- a/base/deploy/src/scriptlets/initialization.py
+++ b/base/deploy/src/scriptlets/initialization.py
@@ -72,19 +72,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         util.configuration_file.verify_selinux_ports()
         return self.rv
 
-    def respawn(self):
-        # begin official logging
-        config.pki_log.info(log.PKIRESPAWN_BEGIN_MESSAGE_2,
-                            master['pki_subsystem'],
-                            master['pki_instance_name'],
-                            extra=config.PKI_INDENTATION_LEVEL_0)
-        config.pki_log.info(log.INITIALIZATION_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        # verify that this type of "subsystem" currently EXISTS
-        # for this "instance"
-        util.instance.verify_subsystem_exists()
-        return self.rv
-
     def destroy(self):
         # begin official logging
         config.pki_log.info(log.PKIDESTROY_BEGIN_MESSAGE_2,
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
index 843227a84e981ac109890a8c3410ae4bec4b739e..07ae03e9a00c3466cdfe23410f1ebe0259c89847 100644
--- a/base/deploy/src/scriptlets/instance_layout.py
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -144,11 +144,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             master['pki_instance_logs_link'])
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.INSTANCE_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         config.pki_log.info(log.INSTANCE_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
diff --git a/base/deploy/src/scriptlets/pkiconfig.py b/base/deploy/src/scriptlets/pkiconfig.py
index ad6c2225116d6f95d85ceaa1b94e0a7a2cccd0fe..3a3a7df18f376a13ea61477618876aa5eebf4d42 100644
--- a/base/deploy/src/scriptlets/pkiconfig.py
+++ b/base/deploy/src/scriptlets/pkiconfig.py
@@ -114,10 +114,6 @@ pki_deployed_instance_name = None
 pki_secdomain_user = None
 pki_secdomain_pass = None
 
-# PKI Deployment "Optional" Command-Line Variables
-#     'pkispawn' ONLY
-pki_update_flag = False
-
 # PKI Deployment "Test" Command-Line Variables
 pki_root_prefix = None
 
diff --git a/base/deploy/src/scriptlets/pkimessages.py b/base/deploy/src/scriptlets/pkimessages.py
index a6361dc8bf3d588dd4509a33f04e1511ecb786ad..8a3a280f32a62e14c3b7da986ba606a837e4ce2d 100644
--- a/base/deploy/src/scriptlets/pkimessages.py
+++ b/base/deploy/src/scriptlets/pkimessages.py
@@ -121,10 +121,6 @@ PKIDESTROY_EPILOG =\
 "    prepended to the default PKI instance path which is placed in front\n"\
 "    of the specified '-i <instance>' parameter.\n\n" +\
 PKI_VERBOSITY
-PKIRESPAWN_BEGIN_MESSAGE_2 = "BEGIN respawning subsystem '%s' of "\
-                             "instance '%s' . . ."
-PKIRESPAWN_END_MESSAGE_2 = "END respawning subsystem '%s' of "\
-                           "instance '%s'"
 PKISPAWN_BEGIN_MESSAGE_2 = "BEGIN spawning subsystem '%s' of "\
                            "instance '%s' . . ."
 PKISPAWN_END_MESSAGE_2 = "END spawning subsystem '%s' of "\
@@ -314,39 +310,28 @@ PKI_CONFIG_NOT_YET_IMPLEMENTED_1 = " %s NOT YET IMPLEMENTED"
 
 # PKI Deployment "Scriptlet" Messages
 ADMIN_DOMAIN_DESTROY_1 = "depopulating '%s'"
-ADMIN_DOMAIN_RESPAWN_1 = "repopulating '%s'"
 ADMIN_DOMAIN_SPAWN_1 = "populating '%s'"
 CONFIGURATION_DESTROY_1 = "unconfiguring '%s'"
-CONFIGURATION_RESPAWN_1 = "reconfiguring '%s'"
 CONFIGURATION_SPAWN_1 = "configuring '%s'"
 FINALIZATION_DESTROY_1 = "finalizing '%s'"
-FINALIZATION_RESPAWN_1 = "finalizing '%s'"
 FINALIZATION_SPAWN_1 = "finalizing '%s'"
 INITIALIZATION_DESTROY_1 = "initializing '%s'"
-INITIALIZATION_RESPAWN_1 = "initializing '%s'"
 INITIALIZATION_SPAWN_1 = "initializing '%s'"
 INSTANCE_DESTROY_1 = "depopulating '%s'"
-INSTANCE_RESPAWN_1 = "repopulating '%s'"
 INSTANCE_SPAWN_1 = "populating '%s'"
 RESIDUAL_DESTROY_1 = "depopulating '%s'"
-RESIDUAL_RESPAWN_1 = "repopulating '%s'"
 RESIDUAL_SPAWN_1 = "populating '%s'"
 SECURITY_DATABASES_DESTROY_1 = "removing '%s'"
-SECURITY_DATABASES_RESPAWN_1 = "regenerating '%s'"
 SECURITY_DATABASES_SPAWN_1 = "generating '%s'"
 SELINUX_DESTROY_1 = "depopulating '%s'"
-SELINUX_RESPAWN_1 = "repopulating '%s'"
 SELINUX_SPAWN_1 = "populating '%s'"
 SELINUX_DISABLED_DESTROY_1 = "selinux disabled. skipping unlabelling '%s'"
 SELINUX_DISABLED_SPAWN_1 = "selinux disabled. skipping labelling '%s'"
 SLOT_ASSIGNMENT_DESTROY_1 = "unassigning slots for '%s'"
-SLOT_ASSIGNMENT_RESPAWN_1 = "reassigning slots for '%s'"
 SLOT_ASSIGNMENT_SPAWN_1 = "assigning slots for '%s'"
 SUBSYSTEM_DESTROY_1 = "depopulating '%s'"
-SUBSYSTEM_RESPAWN_1 = "repopulating '%s'"
 SUBSYSTEM_SPAWN_1 = "populating '%s'"
 WEBAPP_DEPLOYMENT_DESTROY_1 = "removing '%s'"
-WEBAPP_DEPLOYMENT_RESPAWN_1 = "redeploying '%s'"
 WEBAPP_DEPLOYMENT_SPAWN_1 = "deploying '%s'"
 SKIP_ADMIN_DOMAIN_SPAWN_1 = "skip populating '%s'"
 SKIP_CONFIGURATION_SPAWN_1 = "skip configuring '%s'"
diff --git a/base/deploy/src/scriptlets/pkiparser.py b/base/deploy/src/scriptlets/pkiparser.py
index c4bf9b886ee3bd77ed11a6955c57efbf0188d41a..047e8614eeb6d5a9f3e1ceaeb631738ae86fae74 100644
--- a/base/deploy/src/scriptlets/pkiparser.py
+++ b/base/deploy/src/scriptlets/pkiparser.py
@@ -412,7 +412,7 @@ class PKIConfigParser:
     def compose_pki_master_dictionary(self):
         "Create a single master PKI dictionary from the sectional dictionaries"
         try:
-            # 'pkispawn'/'pkirespawn'/'pkidestroy' name/value pairs
+            # 'pkispawn'/'pkidestroy' name/value pairs
             config.pki_master_dict['pki_deployment_executable'] =\
                 config.pki_deployment_executable
             config.pki_master_dict['pki_install_time'] = config.pki_install_time
@@ -987,16 +987,6 @@ class PKIConfigParser:
                 "spawn" + "_" +\
                 config.USER_DEPLOYMENT_CONFIGURATION + "." +\
                 config.pki_master_dict['pki_timestamp']
-            config.pki_master_dict['pki_default_deployment_cfg_respawn_archive'] =\
-                config.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
-                "respawn" + "_" +\
-                config.DEFAULT_DEPLOYMENT_CONFIGURATION + "." +\
-                config.pki_master_dict['pki_timestamp']
-            config.pki_master_dict['pki_user_deployment_cfg_respawn_archive'] =\
-                config.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
-                "respawn" + "_" +\
-                config.USER_DEPLOYMENT_CONFIGURATION + "." +\
-                config.pki_master_dict['pki_timestamp']
             config.pki_master_dict['pki_manifest'] =\
                 config.pki_master_dict['pki_subsystem_registry_path'] + "/" +\
                 "manifest"
@@ -1004,10 +994,6 @@ class PKIConfigParser:
                 config.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
                 "spawn" + "_" + "manifest" + "." +\
                 config.pki_master_dict['pki_timestamp']
-            config.pki_master_dict['pki_manifest_respawn_archive'] =\
-                config.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
-                "respawn" + "_" + "manifest" + "." +\
-                config.pki_master_dict['pki_timestamp']
             # Construct the configuration URL containing the one-time pin
             # and add this to the "sensitive" key value pairs read in from
             # the configuration file
diff --git a/base/deploy/src/scriptlets/pkiscriptlet.py b/base/deploy/src/scriptlets/pkiscriptlet.py
index 767b3c6096227fce67ea1043939753661b33e7d7..28706d01c484199a67dfbb8802a1b52fa3d79365 100644
--- a/base/deploy/src/scriptlets/pkiscriptlet.py
+++ b/base/deploy/src/scriptlets/pkiscriptlet.py
@@ -34,12 +34,6 @@ class AbstractBasePkiScriptlet(object):
         return
 
     @abc.abstractmethod
-    def respawn(self):
-        """Retrieve data from the specified PKI dictionary and
-           use it to update an existing PKI instance."""
-        return
-
-    @abc.abstractmethod
     def destroy(self):
         """Retrieve data from the specified PKI dictionary and
            use it to destroy an existing PKI instance."""
diff --git a/base/deploy/src/scriptlets/security_databases.py b/base/deploy/src/scriptlets/security_databases.py
index 9ac4784e5933ce148961669100416a9f767a47bd..029b8ebef7015a7b0711fe843558fabc742dbe07 100644
--- a/base/deploy/src/scriptlets/security_databases.py
+++ b/base/deploy/src/scriptlets/security_databases.py
@@ -96,11 +96,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             util.file.delete(master['pki_shared_pfile'])
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.SECURITY_DATABASES_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         config.pki_log.info(log.SECURITY_DATABASES_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
diff --git a/base/deploy/src/scriptlets/selinux_setup.py b/base/deploy/src/scriptlets/selinux_setup.py
index 552ab3f41572e51e599daf9ce2d7e0c7b46e2a1b..ee43769bc0224964b024f9e21e40268dfcc6313a 100644
--- a/base/deploy/src/scriptlets/selinux_setup.py
+++ b/base/deploy/src/scriptlets/selinux_setup.py
@@ -110,12 +110,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         self.restore_context()
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.SELINUX_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        self.restore_context()
-        return self.rv
-
     def destroy(self):
         if not bool(selinux.is_selinux_enabled()):
             config.pki_log.info(log.SELINUX_DISABLED_DESTROY_1, __name__,
diff --git a/base/deploy/src/scriptlets/slot_substitution.py b/base/deploy/src/scriptlets/slot_substitution.py
index 205ed49f643c9d166d674c667c30c64eeee8f2bd..7904762cc6914b3951b4102f10bf66f6bc70a00e 100644
--- a/base/deploy/src/scriptlets/slot_substitution.py
+++ b/base/deploy/src/scriptlets/slot_substitution.py
@@ -90,11 +90,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                     master['pki_target_profileselect_template'])
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.SLOT_ASSIGNMENT_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         config.pki_log.info(log.SLOT_ASSIGNMENT_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
diff --git a/base/deploy/src/scriptlets/subsystem_layout.py b/base/deploy/src/scriptlets/subsystem_layout.py
index c4c4c228376872202df470dc1ecbabe8fdc28238..f340ead4969bdeb5ff059890edb6a51d1428ed84 100644
--- a/base/deploy/src/scriptlets/subsystem_layout.py
+++ b/base/deploy/src/scriptlets/subsystem_layout.py
@@ -101,11 +101,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             master['pki_subsystem_registry_link'])
         return self.rv
 
-    def respawn(self):
-        config.pki_log.info(log.SUBSYSTEM_RESPAWN_1, __name__,
-                            extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         config.pki_log.info(log.SUBSYSTEM_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
diff --git a/base/deploy/src/scriptlets/webapp_deployment.py b/base/deploy/src/scriptlets/webapp_deployment.py
index e72752ee876e33b4842f3a8c49b08f6b80cbbc39..4fdcc8614baf2bc816fc865ca3bf420ba6ef5091 100644
--- a/base/deploy/src/scriptlets/webapp_deployment.py
+++ b/base/deploy/src/scriptlets/webapp_deployment.py
@@ -156,12 +156,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             util.directory.set_mode(master['pki_tomcat_webapps_subsystem_path'])
         return self.rv
 
-    def respawn(self):
-        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
-            config.pki_log.info(log.WEBAPP_DEPLOYMENT_RESPAWN_1, __name__,
-                                extra=config.PKI_INDENTATION_LEVEL_1)
-        return self.rv
-
     def destroy(self):
         if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             config.pki_log.info(log.WEBAPP_DEPLOYMENT_DESTROY_1, __name__,
-- 
1.7.10.2