From ecf6fed49192323aee5afae7969410b3252ab787 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Thu, 16 Aug 2012 22:32:44 -0500
Subject: [PATCH] Added pki-base and pki-server RPM packages.

The pki-common package has been split such that the common and
client binaries are packaged in pki-base and server binaries are
packaged in pki-server. The pki-util has been merged into pki-base
and the pki-deploy package has been merged into pki-server.

Ticket #295
---
 scripts/build_dogtag_pki   |   7 +-
 specs/dogtag-pki.spec      |  10 +-
 specs/pki-console.spec     |   9 +-
 specs/pki-core.spec        | 307 ++++++++++++++++++++-------------------------
 specs/pki-ra.spec          |   8 +-
 specs/pki-tps.spec         |   8 +-
 tools/jar/README.jar-tools |   4 +-
 7 files changed, 164 insertions(+), 189 deletions(-)

diff --git a/scripts/build_dogtag_pki b/scripts/build_dogtag_pki
index 6f44dd791776c64fc522b235208e9abfa9fa8f61..73fbf696d0436aead38a4aabbcb2db8aa6a5d60a 100755
--- a/scripts/build_dogtag_pki
+++ b/scripts/build_dogtag_pki
@@ -127,15 +127,14 @@ PKI_TPS_THEME=${PKI_FLAVOR}-pki-tps-theme${RPM_EXT}
 PKI_CONSOLE_THEME=${PKI_FLAVOR}-pki-console-theme${RPM_EXT}
 
 # Establish PKI core package names
-PKI_DEPLOY=pki-deploy${RPM_EXT}
 PKI_SETUP=pki-setup${RPM_EXT}
 PKI_SYMKEY=pki-symkey${RPM_EXT}
 PKI_NATIVE_TOOLS=pki-native-tools${RPM_EXT}
-PKI_UTIL=pki-util${RPM_EXT}
+PKI_BASE=pki-base${RPM_EXT}
 PKI_UTIL_JAVADOC=pki-util-javadoc${RPM_EXT}
 PKI_JAVA_TOOLS=pki-java-tools${RPM_EXT}
 PKI_JAVA_TOOLS_JAVADOC=pki-java-tools-javadoc${RPM_EXT}
-PKI_COMMON=pki-common${RPM_EXT}
+PKI_SERVER=pki-server${RPM_EXT}
 PKI_COMMON_JAVADOC=pki-common-javadoc${RPM_EXT}
 PKI_SELINUX=pki-selinux${RPM_EXT}
 PKI_CA=pki-ca${RPM_EXT}
@@ -176,7 +175,7 @@ cd ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}
 mkdir -p ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
 cp -p ${NOARCH}/*.rpm ${PKI_ARCH}/*.rpm ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
 cd ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
-${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_DEPLOY} ${PKI_SETUP} ${PKI_SYMKEY} ${PKI_NATIVE_TOOLS} ${PKI_UTIL} ${PKI_UTIL_JAVADOC} ${PKI_JAVA_TOOLS} ${PKI_JAVA_TOOLS_JAVADOC} ${PKI_COMMON} ${PKI_COMMON_JAVADOC} ${PKI_SELINUX} ${PKI_CA} ${PKI_KRA} ${PKI_OCSP} ${PKI_TKS} ${PKI_SILENT}
+${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_SETUP} ${PKI_SYMKEY} ${PKI_NATIVE_TOOLS} ${PKI_BASE} ${PKI_UTIL_JAVADOC} ${PKI_JAVA_TOOLS} ${PKI_JAVA_TOOLS_JAVADOC} ${PKI_SERVER} ${PKI_COMMON_JAVADOC} ${PKI_SELINUX} ${PKI_CA} ${PKI_KRA} ${PKI_OCSP} ${PKI_TKS} ${PKI_SILENT}
 
 # Compose and install 'pki-ra' packages
 cd ${PKI_PWD}
diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index 10a2bae1ab7f655c0ed4646a88e086bcc1ef80ba..d93904e4746232d99f739e197b83b99ce1d7a3ff 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -8,7 +8,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
 Version:          10.0.0
-Release:          %{?relprefix}6%{?prerel}%{?dist}
+Release:          %{?relprefix}7%{?prerel}%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -96,15 +96,14 @@ Requires:         dogtag-pki-tps-theme >= %{dogtag_pki_theme_version}
 # Make certain that this 'meta' package requires the latest version(s)
 # of ALL Dogtag PKI core packages
 Requires:         pki-ca >= %{pki_core_version}
-Requires:         pki-common >= %{pki_core_version}
-Requires:         pki-deploy >= %{pki_core_version}
+Requires:         pki-server >= %{pki_core_version}
 Requires:         pki-java-tools >= %{pki_core_version}
 Requires:         pki-native-tools >= %{pki_core_version}
 Requires:         pki-selinux >= %{pki_core_version}
 Requires:         pki-setup >= %{pki_core_version}
 Requires:         pki-silent >= %{pki_core_version}
 Requires:         pki-symkey >= %{pki_core_version}
-Requires:         pki-util >= %{pki_core_version}
+Requires:         pki-base >= %{pki_core_version}
 
 # Make certain that this 'meta' package requires the latest version(s)
 # of ALL Dogtag PKI core javadocs
@@ -199,6 +198,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Wed Aug 22 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.7.a1
+- Replaced pki-util, pki-deploy, pki-common with pki-base and pki-server
+
 * Tue Aug 14 2012 Matthew Harmsen <mharmsen@redhat.com> 10.0.0-0.6.a1
 - Updated release of 'tomcatjss' to rely on Tomcat 7 for Fedora 17
 - Added 'pki-deploy' runtime dependency
diff --git a/specs/pki-console.spec b/specs/pki-console.spec
index eaae0d06b35f4e8b86ec49694bbc4a489b406445..e858662c4584b392637117aff87b581997240273 100644
--- a/specs/pki-console.spec
+++ b/specs/pki-console.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-console
 Version:          10.0.0
-Release:          %{?relprefix}5%{?prerel}%{?dist}
+Release:          %{?relprefix}6%{?prerel}%{?dist}
 Summary:          Certificate System - PKI Console
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -31,11 +31,11 @@ BuildRequires:    junit4
 %if 0%{?fedora} >= 16
 BuildRequires:    jpackage-utils >= 1.7.5-10
 BuildRequires:    jss >= 4.2.6-24
-BuildRequires:    pki-util >= 9.0.15
+BuildRequires:    pki-base >= 9.0.15
 %else
 BuildRequires:    jpackage-utils
 BuildRequires:    jss >= 4.2.6-24
-BuildRequires:    pki-util
+BuildRequires:    pki-base
 %endif
 
 Requires:         idm-console-framework
@@ -100,6 +100,9 @@ cd build
 
 
 %changelog
+* Wed Aug 22 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.6.a1
+- Replaced pki-util with pki-base
+
 * Thu Jul 12 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.5.a1
 - Added option to build without Javadoc
 
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 20dfdf34ce4857d5f2f10906b0f8c23bae1936e6..72339f1a3c0f7042835e202baf7b3b87d3962305 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -14,7 +14,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.0.0
-Release:          %{?relprefix}23%{?prerel}%{?dist}
+Release:          %{?relprefix}24%{?prerel}%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -73,7 +73,7 @@ BuildRequires:    tomcatjss >= 2.0.0
 %endif
 %endif
 %endif
-# Add the following build-time requirements to support the "pki-deploy" package
+# Add the following build-time requirements to support the "pki-server" package
 BuildRequires:    pki-common-theme >= 10.0.0
 BuildRequires:    pki-ca-theme >= 10.0.0
 BuildRequires:    pki-kra-theme >= 10.0.0
@@ -120,14 +120,13 @@ PKI Core contains ALL top-level java-based Tomcat PKI components:      \
   * pki-setup                                                          \
   * pki-symkey                                                         \
   * pki-native-tools                                                   \
-  * pki-util                                                           \
   * pki-util-javadoc                                                   \
   * pki-java-tools                                                     \
   * pki-java-tools-javadoc                                             \
-  * pki-common                                                         \
+  * pki-base                                                           \
   * pki-common-javadoc                                                 \
   * pki-selinux                                                        \
-  * pki-deploy                                                         \
+  * pki-server                                                         \
   * pki-ca                                                             \
   * pki-kra                                                            \
   * pki-ocsp                                                           \
@@ -152,10 +151,10 @@ Certificate System instances consisting of the following components:   \
 Additionally, PKI Core contains the following fundamental packages     \
 required ONLY by ALL java-based Tomcat Certificate System instances:   \
                                                                        \
-  * pki-common                                                         \
+  * pki-symkey                                                         \
+  * pki-base                                                           \
+  * pki-server                                                         \
   * pki-java-tools                                                     \
-  * pki-symkey (ONLY required for TKS subsystems)                      \
-  * pki-util                                                           \
                                                                        \
 PKI Core also includes the following components:                       \
                                                                        \
@@ -239,49 +238,12 @@ This package is a part of the PKI Core used by the Certificate System.
 %{overview}
 
 
-%package -n       pki-util
-Summary:          Certificate System - PKI Utility Framework
-Group:            System Environment/Base
-
-BuildArch:        noarch
-
-Requires:         java >= 1:1.6.0
-Requires:         ldapjdk
-Requires:         apache-commons-codec
-%if 0%{?fedora} >= 16
-Requires:         jpackage-utils >= 0:1.7.5-10
-Requires:         jss >= 4.2.6-24
-%else
-%if 0%{?fedora} >= 15
-Requires:         jpackage-utils
-Requires:         jss >= 4.2.6-24
-%else
-Requires:         jpackage-utils
-Requires:         jss >= 4.2.6-17
-%endif
-%endif
-
-%description -n   pki-util
-The PKI Utility Framework is required by the following four PKI subsystems:
-
-    the Certificate Authority (CA),
-    the Data Recovery Manager (DRM),
-    the Online Certificate Status Protocol (OCSP) Manager, and
-    the Token Key Service (TKS).
-
-This package is a part of the PKI Core used by the Certificate System.
-
-%{overview}
-
-
 %package -n       pki-util-javadoc
 Summary:          Certificate System - PKI Utility Framework Javadocs
 Group:            Documentation
 
 BuildArch:        noarch
 
-Requires:         pki-util = %{version}-%{release}
-
 %description -n   pki-util-javadoc
 This documentation pertains exclusively to version %{version} of
 the PKI Utility Framework.
@@ -299,7 +261,7 @@ BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
 Requires:         pki-native-tools = %{version}-%{release}
-Requires:         pki-util = %{version}-%{release}
+Requires:         pki-base = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires:         jpackage-utils >= 0:1.7.5-10
 %else
@@ -321,8 +283,6 @@ Group:            Documentation
 
 BuildArch:        noarch
 
-Requires:         pki-java-tools = %{version}-%{release}
-
 %description -n   pki-java-tools-javadoc
 This documentation pertains exclusively to version %{version} of
 the PKI Java-Based Tools.
@@ -332,21 +292,22 @@ This package is a part of the PKI Core used by the Certificate System.
 %{overview}
 
 
-%package -n       pki-common
-Summary:          Certificate System - PKI Common Framework
+%package -n       pki-base
+Summary:          Certificate System - PKI Framework
 Group:            System Environment/Base
 
 BuildArch:        noarch
 
+Obsoletes:        pki-common < %{version}-%{release}
+Obsoletes:        pki-util < %{version}-%{release}
+
+Requires:         apache-commons-codec
+Requires:         apache-commons-lang
+Requires:         apache-commons-logging
 Requires:         java >= 1:1.6.0
 Requires:         javassist
 Requires:         jettison
-Requires:         jython >= 2.2.1
-Requires:         pki-common-theme >= 10.0.0
-Requires:         pki-java-tools = %{version}-%{release}
-Requires:         pki-setup = %{version}-%{release}
-Requires:         %{_javadir}/ldapjdk.jar
-Requires:         %{_javadir}/velocity.jar
+Requires:         ldapjdk
 Requires:         %{_javadir}/xalan-j2.jar
 Requires:         %{_javadir}/xalan-j2-serializer.jar
 Requires:         %{_javadir}/xerces-j2.jar
@@ -355,65 +316,32 @@ Requires:         %{_javadir}/xml-commons-resolver.jar
 Requires:         velocity
 %if 0%{?fedora} >= 17
 Requires:         resteasy >= 2.3.2-1
-Requires:         tomcatjss >= 7.0.0
 %endif
 %if 0%{?fedora} >= 18
-Requires:         apache-commons-lang
-Requires:         apache-commons-logging
+Requires:         jpackage-utils >= 0:1.7.5-10
 Requires:         jss >= 4.2.6-24
-Requires(post):   systemd-units
-Requires(preun):  systemd-units
-Requires(postun): systemd-units
-Requires:         tomcatjss >= 7.0.0
 %else
 %if 0%{?fedora} >= 16
-Requires:         apache-commons-lang
-Requires:         apache-commons-logging
+Requires:         jpackage-utils >= 0:1.7.5-10
 Requires:         jss >= 4.2.6-24
-Requires(post):   systemd-units
-Requires(preun):  systemd-units
-Requires(postun): systemd-units
-Requires:         tomcatjss >= 6.0.2
 %else
 %if 0%{?fedora} >= 15
-Requires:         apache-commons-lang
-Requires:         apache-commons-logging
-Requires(post):   chkconfig
-Requires(preun):  chkconfig
-Requires(preun):  initscripts
-Requires(postun): initscripts
-# Details:
-#
-#     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
-#     * https://fedoraproject.org/wiki/Tmpfiles.d_packaging_draft
-#
-Requires:         initscripts
+Requires:         jpackage-utils
 Requires:         jss >= 4.2.6-24
-Requires:         tomcatjss >= 6.0.0
 %else
 %if 0%{?fedora} >= 14
-Requires:         apache-commons-lang
-Requires:         apache-commons-logging
+Requires:         jpackage-utils
 Requires:         jss >= 4.2.6-17
-Requires:         tomcatjss >= 2.0.0
 %else
-Requires:         jakarta-commons-lang
-Requires:         jakarta-commons-logging
+Requires:         jpackage-utils
 Requires:         jss >= 4.2.6-17
-Requires:         tomcatjss >= 2.0.0
 %endif
 %endif
 %endif
 %endif
 
-%description -n   pki-common
-The PKI Common Framework is required by the following four PKI subsystems:
-
-    the Certificate Authority (CA),
-    the Data Recovery Manager (DRM),
-    the Online Certificate Status Protocol (OCSP) Manager, and
-    the Token Key Service (TKS).
-
+%description -n   pki-base
+The PKI Framework contains the common and client libraries and utilities.
 This package is a part of the PKI Core used by the Certificate System.
 
 %{overview}
@@ -425,8 +353,6 @@ Group:            Documentation
 
 BuildArch:        noarch
 
-Requires:         pki-common = %{version}-%{release}
-
 %description -n   pki-common-javadoc
 This documentation pertains exclusively to version %{version} of
 the PKI Common Framework.
@@ -436,6 +362,67 @@ This package is a part of the PKI Core used by the Certificate System.
 %{overview}
 
 
+%package -n       pki-server
+Summary:          Certificate System - PKI Server Framework
+Group:            System Environment/Base
+
+BuildArch:        noarch
+
+Obsoletes:        pki-deploy < %{version}-%{release}
+
+Requires:         jython >= 2.2.1
+Requires:         pki-common-theme >= 10.0.0
+Requires:         pki-base = %{version}-%{release}
+Requires:         pki-selinux = %{version}-%{release}
+Requires:         %{_javadir}/velocity.jar
+%if 0%{?fedora} >= 17
+Requires(post):   systemd-units
+Requires(preun):  systemd-units
+Requires(postun): systemd-units
+Requires:         tomcatjss >= 7.0.0
+%else
+%if 0%{?fedora} >= 16
+Requires(post):   systemd-units
+Requires(preun):  systemd-units
+Requires(postun): systemd-units
+Requires:         tomcatjss >= 6.0.2
+%else
+%if 0%{?fedora} >= 15
+Requires(post):   chkconfig
+Requires(preun):  chkconfig
+Requires(preun):  initscripts
+Requires(postun): initscripts
+# Details:
+#
+#     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
+#     * https://fedoraproject.org/wiki/Tmpfiles.d_packaging_draft
+#
+Requires:         initscripts
+Requires:         tomcatjss >= 6.0.0
+%else
+%if 0%{?fedora} >= 14
+Requires:         tomcatjss >= 2.0.0
+%else
+Requires:         tomcatjss >= 2.0.0
+%endif
+%endif
+%endif
+%endif
+
+%description -n   pki-server
+The PKI Server Framework is required by the following four PKI subsystems:
+
+    the Certificate Authority (CA),
+    the Data Recovery Manager (DRM),
+    the Online Certificate Status Protocol (OCSP) Manager, and
+    the Token Key Service (TKS).
+
+This package is a part of the PKI Core used by the Certificate System.
+The package contains scripts to create and remove PKI subsystems.
+
+%{overview}
+
+
 %package -n       pki-selinux
 Summary:          Certificate System - PKI Selinux Policies
 Group:            System Environment/Base
@@ -453,23 +440,6 @@ This package is a part of the PKI Core used by the Certificate System.
 %{overview}
 
 
-%package -n       pki-deploy
-Summary:          Certificate System - PKI Instance Deployment Scripts
-Group:            System Environment/Base
-
-BuildArch:        noarch
-
-Requires:         pki-common = %{version}-%{release}
-
-%description -n   pki-deploy
-PKI deployment scripts are used to create and remove instances from
-PKI deployments.
-
-This package is a part of the PKI Core used by the Certificate System.
-
-%{overview}
-
-
 %package -n       pki-ca
 Summary:          Certificate System - Certificate Authority
 Group:            System Environment/Daemons
@@ -478,8 +448,7 @@ BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
 Requires:         pki-ca-theme >= 10.0.0
-Requires:         pki-deploy = %{version}-%{release}
-Requires:         pki-selinux = %{version}-%{release}
+Requires:         pki-server = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
@@ -527,8 +496,7 @@ BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
 Requires:         pki-kra-theme >= 10.0.0
-Requires:         pki-deploy = %{version}-%{release}
-Requires:         pki-selinux = %{version}-%{release}
+Requires:         pki-server = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
@@ -582,8 +550,7 @@ BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
 Requires:         pki-ocsp-theme >= 10.0.0
-Requires:         pki-deploy = %{version}-%{release}
-Requires:         pki-selinux = %{version}-%{release}
+Requires:         pki-server = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
@@ -644,8 +611,7 @@ BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
 Requires:         pki-tks-theme >= 10.0.0
-Requires:         pki-deploy = %{version}-%{release}
-Requires:         pki-selinux = %{version}-%{release}
+Requires:         pki-server = %{version}-%{release}
 Requires:         pki-symkey = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires(post):   systemd-units
@@ -700,7 +666,7 @@ Group:            System Environment/Base
 BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
-Requires:         pki-common = %{version}-%{release}
+Requires:         pki-server = %{version}-%{release}
 
 %description -n   pki-silent
 The PKI Silent Installer may be used to "automatically" configure
@@ -1056,7 +1022,7 @@ fi
 %fix_tomcat_log tks
 
 
-## %post -n pki-common
+## %post -n pki-server
 ## NOTE:  At this time, NO attempt has been made to update ANY PKI subsystem
 ##        from EITHER 'sysVinit' OR previous 'systemd' processes to the new
 ##        PKI deployment process
@@ -1090,7 +1056,7 @@ if [ $1 = 0 ] ; then
 fi
 
 
-## %preun -n pki-common
+## %preun -n pki-server
 ## NOTE:  At this time, NO attempt has been made to update ANY PKI subsystem
 ##        from EITHER 'sysVinit' OR previous 'systemd' processes to the new
 ##        PKI deployment process
@@ -1124,7 +1090,7 @@ if [ "$1" -ge "1" ] ; then
 fi
 
 
-## %postun -n pki-common
+## %postun -n pki-server
 ## NOTE:  At this time, NO attempt has been made to update ANY PKI subsystem
 ##        from EITHER 'sysVinit' OR previous 'systemd' processes to the new
 ##        PKI deployment process
@@ -1168,15 +1134,6 @@ fi
 %{_datadir}/pki/native-tools/
 
 
-%files -n pki-util
-%defattr(-,root,root,-)
-%doc base/util/LICENSE
-%dir %{_javadir}/pki
-%{_javadir}/pki/pki-cmsutil-%{version}.jar
-%{_javadir}/pki/pki-cmsutil.jar
-%{_javadir}/pki/pki-nsutil-%{version}.jar
-%{_javadir}/pki/pki-nsutil.jar
-
 %if %{?_without_javadoc:0}%{!?_without_javadoc:1}
 %files -n pki-util-javadoc
 %defattr(-,root,root,-)
@@ -1218,39 +1175,18 @@ fi
 %endif
 
 
-%files -n pki-common
+%files -n pki-base
 %defattr(-,root,root,-)
 %doc base/common/LICENSE
-%if 0%{?fedora} >= 16
-%dir %{_sysconfdir}/systemd/system/pki-tomcatd.target.wants
-%{_unitdir}/pki-tomcatd@.service
-%{_unitdir}/pki-tomcatd.target
-%endif
+%dir %{_javadir}/pki
+%{_javadir}/pki/pki-cmsutil-%{version}.jar
+%{_javadir}/pki/pki-cmsutil.jar
+%{_javadir}/pki/pki-nsutil-%{version}.jar
+%{_javadir}/pki/pki-nsutil.jar
 %{_javadir}/pki/pki-certsrv-%{version}.jar
 %{_javadir}/pki/pki-certsrv.jar
 %{_javadir}/pki/pki-client-%{version}.jar
 %{_javadir}/pki/pki-client.jar
-%{_javadir}/pki/pki-cms-%{version}.jar
-%{_javadir}/pki/pki-cms.jar
-%{_javadir}/pki/pki-cmsbundle-%{version}.jar
-%{_javadir}/pki/pki-cmsbundle.jar
-%{_javadir}/pki/pki-cmscore-%{version}.jar
-%{_javadir}/pki/pki-cmscore.jar
-%dir %{_localstatedir}/lock/pki/tomcat
-%dir %{_localstatedir}/run/pki/tomcat
-
-%if 0%{?fedora} >= 15
-# Details:
-#
-#     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
-#     * https://fedoraproject.org/wiki/Tmpfiles.d_packaging_draft
-#
-%config(noreplace) %{_sysconfdir}/tmpfiles.d/pki-tomcat.conf
-%endif
-
-%{_datadir}/pki/setup/
-%dir %{_datadir}/pki/shared
-%{_datadir}/pki/shared/conf/
 
 %if %{?_without_javadoc:0}%{!?_without_javadoc:1}
 %files -n pki-common-javadoc
@@ -1259,13 +1195,7 @@ fi
 %endif
 
 
-%files -n pki-selinux
-%defattr(-,root,root,-)
-%doc base/selinux/LICENSE
-%{_datadir}/selinux/modules/pki.pp
-
-
-%files -n pki-deploy
+%files -n pki-server
 %defattr(-,root,root,-)
 %doc base/deploy/LICENSE
 %{_bindir}/pkispawn
@@ -1298,6 +1228,38 @@ fi
 %if 0%{?fedora} >= 16
 %{_bindir}/pkidaemon
 %endif
+%if 0%{?fedora} >= 16
+%dir %{_sysconfdir}/systemd/system/pki-tomcatd.target.wants
+%{_unitdir}/pki-tomcatd@.service
+%{_unitdir}/pki-tomcatd.target
+%endif
+%{_javadir}/pki/pki-cms-%{version}.jar
+%{_javadir}/pki/pki-cms.jar
+%{_javadir}/pki/pki-cmsbundle-%{version}.jar
+%{_javadir}/pki/pki-cmsbundle.jar
+%{_javadir}/pki/pki-cmscore-%{version}.jar
+%{_javadir}/pki/pki-cmscore.jar
+%dir %{_localstatedir}/lock/pki/tomcat
+%dir %{_localstatedir}/run/pki/tomcat
+
+%if 0%{?fedora} >= 15
+# Details:
+#
+#     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
+#     * https://fedoraproject.org/wiki/Tmpfiles.d_packaging_draft
+#
+%config(noreplace) %{_sysconfdir}/tmpfiles.d/pki-tomcat.conf
+%endif
+
+%{_datadir}/pki/setup/
+%dir %{_datadir}/pki/shared
+%{_datadir}/pki/shared/conf/
+
+
+%files -n pki-selinux
+%defattr(-,root,root,-)
+%doc base/selinux/LICENSE
+%{_datadir}/selinux/modules/pki.pp
 
 
 %files -n pki-ca
@@ -1429,6 +1391,11 @@ fi
 
 
 %changelog
+* Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.24.a1
+- Split pki-common into pki-base and pki-server.
+- Merged pki-util into pki-base.
+- Merged pki-deploy into pki-server.
+
 * Thu Aug 16 2012 Matthew Harmsen <mharmsen@redhat.com> 10.0.0-0.23.a1
 - Updated release of 'tomcatjss' to rely on Tomcat 7 for Fedora 17
 - Changed Dogtag 10 build-time and runtime requirements for 'pki-deploy'
diff --git a/specs/pki-ra.spec b/specs/pki-ra.spec
index e500826e27c49af64d18c444ed6333c97a5a8cc3..b212007cbd9237e91ec2f0b098928fce0e4d33a2 100644
--- a/specs/pki-ra.spec
+++ b/specs/pki-ra.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-ra
 Version:          10.0.0
-Release:          %{?relprefix}3%{?prerel}%{?dist}
+Release:          %{?relprefix}4%{?prerel}%{?dist}
 Summary:          Certificate System - Registration Authority
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -29,10 +29,9 @@ BuildRequires:    nss-devel
 Requires:         mod_nss >= 1.0.8
 Requires:         mod_perl >= 1.99_16
 Requires:         mod_revocator >= 1.0.3
-Requires:         pki-deploy >= 10.0.0
+Requires:         pki-server >= 10.0.0
 Requires:         pki-native-tools >= 10.0.0
 Requires:         pki-ra-theme >= 10.0.0
-Requires:         pki-selinux >= 10.0.0
 Requires:         pki-setup
 Requires:         perl-DBD-SQLite
 Requires:         sqlite
@@ -245,6 +244,9 @@ fi
 
 
 %changelog
+* Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.4.a1
+- Replaced 'pki-deploy' with 'pki-server'.
+
 * Thu Aug 16 2012 Matthew Harmsen <mharmsen@redhat.com> 10.0.0-0.3.a1
 - Added 'pki-deploy' runtime dependency
 
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index 6845dd485d98253af01f65dd2378797440ce39f4..16f88d74e2fe6b48971d6d4e85ae2d980dd4160e 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-tps
 Version:          10.0.0
-Release:          %{?relprefix}3%{?prerel}%{?dist}
+Release:          %{?relprefix}4%{?prerel}%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
 License:          LGPLv2
@@ -38,9 +38,8 @@ Requires:         mod_perl
 Requires:         mod_revocator
 Requires:         openldap-clients
 Requires:         perl-Mozilla-LDAP
-Requires:         pki-deploy >= 10.0.0
+Requires:         pki-server >= 10.0.0
 Requires:         pki-native-tools >= 10.0.0
-Requires:         pki-selinux >= 10.0.0
 Requires:         pki-setup
 Requires:         pki-tps-theme >= 10.0.0
 
@@ -280,6 +279,9 @@ fi
 
 
 %changelog
+* Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.4.a1
+- Replaced 'pki-deploy' with 'pki-server'.
+
 * Thu Aug 16 2012 Matthew Harmsen <mharmsen@redhat.com> 10.0.0-0.3.a1
 - Changed 'httpd-devel' build-time dependency to require '2.4.2'
 - Added 'pki-deploy' runtime dependency
diff --git a/tools/jar/README.jar-tools b/tools/jar/README.jar-tools
index e165fd8bd4a24be6ef2f80aa64d551aced29fe64..cf0d8011ee87f00ad4e7f9b542b37b3472961225 100644
--- a/tools/jar/README.jar-tools
+++ b/tools/jar/README.jar-tools
@@ -252,10 +252,10 @@ Summary:
      jss
      ldapjdk
      apache-commons-codec
-     pki-common
+     pki-server
      pki-console
      pki-symkey
-     pki-util
+     pki-base
      tomcat5-jsp-2.0-api
      tomcat5-servlet-2.4-api
      tomcat6-jsp-2.1-api
-- 
1.7.11.2